(define his-pasteboard%
  (class pasteboard% ()	 
    (override 	  
      (on-default-event 	   
       (lambda (event)
	     (let* ((type (send event get-event-type))
		    (x (send event get-x))
                    (y (send event get-y))
                    (indice-x (inexact->exact (quotient x IMG-SIZE)))
		    (indice-y (inexact->exact (quotient y IMG-SIZE)))   
                    (s (send this find-snip x y))
                    (checked? (eq? (status? his-grid-vect indice-x indice-y) 'checked)))
               (if end-of-game?  
                   (end-of-game-greeting))
               (cond
                 ((or (< indice-x 0) (> indice-x (sub1 WIDTH)) 
                      (< indice-y 0) (> indice-y (sub1 HEIGHT)) (not s)) 
                  ())
                 ((not game-started?) ())
                 ((eq? type 'left-down)
                     (begin
                       (if (not checked?)
                           (play-sound "tir.wav" #f))
                       (case (status? his-grid-vect indice-x indice-y)
                         ((checked) 
                          (send message set-label "CELL ALREADY CHECKED !!! CHOOSE ANOTHER ONE !"))
                         ((empty)  
                          (send s set-bitmap empty-is) (play-sound "splash.wav" #f))
                         ((type-1)
                          (if show?
                              (send s set-bitmap explosion-1-is)(send s set-bitmap explosion-is))
                              (play-sound "boom.wav" #f)
                          (set! i-bombed (add1 i-bombed))(status! coulee indice-x indice-y 6)
                          (a-ajouter indice-x indice-y 6)(test-end-of-game))
                         ((type-2)
                          (if show?
                              (send s set-bitmap explosion-2-is)(send s set-bitmap explosion-is))
                              (play-sound "boom.wav" #f)
                          (set! i-bombed (add1 i-bombed))(status! coulee indice-x indice-y 7)
                          (a-ajouter indice-x indice-y 7)(test-end-of-game))
                         ((type-3)
                          (if show?
                              (send s set-bitmap explosion-3-is)(send s set-bitmap explosion-is))
                              (play-sound "boom.wav" #f)
                          (set! i-bombed (add1 i-bombed))(status! coulee indice-x indice-y 8)
                          (a-ajouter indice-x indice-y 8)(test-end-of-game))
                         ((type-4)
                          (if show?
                              (send s set-bitmap explosion-4-is)(send s set-bitmap explosion-is))
                              (play-sound "boom.wav" #f)
                          (set! i-bombed (add1 i-bombed))(status! coulee indice-x indice-y 9)
                          (a-ajouter indice-x indice-y 9)(test-end-of-game))
                         ((type-5)
                          (if show?
                              (send s set-bitmap explosion-5-is)(send s set-bitmap explosion-is))
                              (play-sound "boom.wav" #f)
                          (set! i-bombed (add1 i-bombed))(status! coulee indice-x indice-y 10)
                          (a-ajouter indice-x indice-y 10)(test-end-of-game)))
                       (if (not checked?)
                           (begin
                             (send message set-label "")
                             (status! his-grid-vect indice-x indice-y 'checked)
                             (set! move (generate-move)) 
                             (send my-pasteboard effect-move (analyse-move move)))))))))))
    (sequence (super-init))))

(define his-pasteboard-net%
  (class pasteboard% ()
    (public
      (my-turn
       (lambda ()
         (if first-move?
             (if host?
                 void
                 (begin
                   (printf "entree get-move~n")
                   (set! answer (loop-till-1))
                   (printf "sortie get-move ~a~n" (loop-till-1))
                   (send my-pasteboard effect-answer-ret-t 
                     (analyse-move answer))))
             (begin
               (printf "entree get-move~n")
                   (if host?
                       (begin
                         (set! answer (loop-till-0))
                         (printf "sortie get-move ~a~n" (loop-till-0)))
                       (begin
                         (set! answer (loop-till-1))
                         (printf "sortie get-move ~a~n" (loop-till-1))))
                   (printf "req-t ~a~n" answer-t)
                   (set! answer-t (car (analyse-move answer)))
                   (printf "req-t ~a~n" answer-t)
                   (send my-pasteboard get-t)
                   (send my-pasteboard effect-answer-ret-t 
                     (analyse-move answer)))))))
    (override 	  
      (on-default-event 	   
       (lambda (event)
	     (let* ((type (send event get-event-type))
		    (x (send event get-x))
                    (y (send event get-y))
                    (indice-x (inexact->exact (quotient x IMG-SIZE)))
		    (indice-y (inexact->exact (quotient y IMG-SIZE)))
                    (s (send this find-snip x y)))
               (if end-of-game?  
                   (end-of-game-greeting))
               (cond
                 ((or (< indice-x 0) (> indice-x (sub1 WIDTH)) 
                      (< indice-y 0) (> indice-y (sub1 HEIGHT)) (not s)) 
                  ())
                 ((not game-started?) ())
                 ((eq? type 'left-down)
                     (begin
                       (if (eq? (status? his-grid-vect indice-x indice-y) 'checked)
                             (send message set-label "CELL ALREADY CHECKED !!! CHOOSE ANOTHER ONE !")
                           (begin
                             (play-sound "tir.wav" #f)
                             ;(a-ajouter his-grid-vect indice-x indice-y)
                             (status! his-grid-vect indice-x indice-y 'checked)
                             (set! last-move (cons indice-x (cons indice-y '())))
                             (set! request (string-append "t" (number->string request-t) "t"
                                                          "x" (number->string indice-x) "x"
                                                          "y" (number->string indice-y) "y"))
                             (printf "entree his~n") 
                             (if host?
                                 (if first-move?
                                     (begin
                                       (flag0!)
                                       (set! request (string-append 
                                                      "t" "f" "t"
                                                      "x" (number->string indice-x) "x"
                                                      "y" (number->string indice-y) "y"))
                                       (printf "request : ~a~n" request)
                                       (printf "envoie request~n")
                                       (home->away request)
                                       (flag1!))
                                     (begin 
                                       (loop-till-0)
                                       (printf "request : ~a~n" request)
                                       (printf "envoie request~n")
                                       (home->away request)
                                       (printf "passer tour a 1~n")
                                       (flag1!)))
                                 (begin
                                   (loop-till-1)
                                   (printf "request : ~a~n" request)
                                   (printf "envoie request~n")
                                   (home->away request)
                                   (printf "passer tour a 0~n")
                                   (flag0!)))
                             (if first-move?
                                 (set! first-move? #f)
                                 )
                             (printf "sortie his~n")
                             )))))))))
    (sequence (super-init))))
