(define super-frame (make-object frame% "Naval Combat v.1.0b" #f 860 525))

(define hp-up (make-object horizontal-panel% super-frame '(border)))
(send hp-up min-height 430)

(define my-pasteboard (make-object (if (eq? game-type 1) my-pasteboard% my-pasteboard-net%)))
(define my-editor-canvas (make-object editor-canvas% hp-up my-pasteboard '(hide-hscroll hide-vscroll)))

(define his-pasteboard (make-object (if (eq? game-type 1) his-pasteboard% his-pasteboard-net%)))
(define his-editor-canvas (make-object editor-canvas% hp-up his-pasteboard '(hide-hscroll hide-vscroll)))

(define hp-down-1 (make-object horizontal-panel% super-frame '(border)))
(send hp-down-1 set-alignment 'center 'center)
(define message (make-object message% "You can read here all the updated messages !         " hp-down-1))

(define hp-down-2 (make-object horizontal-panel% super-frame '(border)))
(send hp-down-2 set-alignment 'center 'center)

(define frame-setting (make-object frame% "Game Settings"))

(define (can-set? bon ben)
  (if game-started?
      (send message set-label "IMPOSSIBLE to set ! Game Already Started !")
      (setting-main 'bon 'ben)))

(define (setting-main bon ben)
  
  (define panel-up-setting (make-object vertical-panel% frame-setting '(border)))
  (define panel-1-setting (make-object horizontal-panel% frame-setting '(border)))
  (define rbs1 (make-object radio-box% "Type-1" '("1" "2" "3" "4" "5") panel-1-setting void '(horizontal)))
  (define panel-2-setting (make-object horizontal-panel% frame-setting '(border)))
  (define rbs2 (make-object radio-box% "Type-2" '("1" "2" "3" "4" "5") panel-2-setting void '(horizontal)))
  (define panel-3-setting (make-object horizontal-panel% frame-setting '(border)))
  (define rbs3 (make-object radio-box% "Type-3" '("1" "2" "3" "4" "5") panel-3-setting void '(horizontal)))
  (define panel-4-setting (make-object horizontal-panel% frame-setting '(border)))
  (define rbs4 (make-object radio-box% "Type-4" '("1" "2" "3" "4" "5") panel-4-setting void '(horizontal)))
  (define panel-5-setting (make-object horizontal-panel% frame-setting '(border)))
  (define rbs5 (make-object radio-box% "Type-5" '("1" "2" "3" "4" "5") panel-5-setting void '(horizontal)))
  (define panel-51-setting (make-object horizontal-panel% frame-setting '(border)))
  (define rbs51 (make-object radio-box% "SHOW THE TYPE OF THE EXPLOSED BOMB?" 
                  '("YES" "NO") panel-51-setting void '(horizontal)))
  (define panel-6-setting (make-object horizontal-panel% frame-setting '(border)))
  (define rbs6 (make-object radio-box% "SIZE-OF-GRID" '("5" "6" "7" "8" "9"
                                                        "10" "11" "12" "13") panel-6-setting void '(horizontal)))
  (define panel-7-setting (make-object horizontal-panel% frame-setting '(border)))
  (define rbs7 (if (= game-type 1)
                   (make-object radio-box% "CHOOSE DIFFICULTY" 
                 '("Level One" "Level Two" "Level Three") panel-7-setting void '(horizontal))
                   (make-object radio-box% "CHOOSE YOUR ROLE" 
                 '("Host" "Guest") panel-7-setting void '(horizontal))))
  (define panel-dn-setting (make-object vertical-panel% frame-setting '(border)))
  
  (send frame-setting maximize #t)
  
  (send rbs1 set-selection 0)
  (send rbs2 set-selection 1)
  (send rbs3 set-selection 1)
  (send rbs4 set-selection 1)
  (send rbs5 set-selection 0)
  (send rbs51 set-selection 0)
  (send rbs6 set-selection 8)
  (if (= game-type 1)
      (send rbs7 set-selection 2)
      (send rbs7 set-selection 0))
  
  (make-object message% "" panel-up-setting)
  (make-object message% "Welcome To The Combat Naval v1.0b !" panel-up-setting)
  (make-object message% "" panel-up-setting)
  (make-object message% "Please Choose the Number Of Ships In Each Category" panel-up-setting)
  (make-object message% "" panel-up-setting)
  (make-object message% "N.B: If (WIDTH*HEIGHT) < (NB-OF-BOMBS) You ll restart the Settings" panel-up-setting)
  
  (send panel-1-setting set-alignment 'center 'center)
  (make-object button% type-1-is panel-1-setting void)
  (make-object button% explosion-1-is panel-1-setting void)
  
  (send panel-2-setting set-alignment 'center 'center)
  (make-object button% type-2-is panel-2-setting void)
  (make-object button% explosion-2-is panel-2-setting void)
  
  (send panel-3-setting set-alignment 'center 'center)
  (make-object button% type-3-is panel-3-setting void)
  (make-object button% explosion-3-is panel-3-setting void)
  
  (send panel-4-setting set-alignment 'center 'center)
  (make-object button% type-4-is panel-4-setting void)
  (make-object button% explosion-4-is panel-4-setting void)
  
  (send panel-5-setting set-alignment 'center 'center)
  (make-object button% type-5-is panel-5-setting void)
  (make-object button% explosion-5-is panel-5-setting void)
  
  (send panel-51-setting set-alignment 'center 'center)
  (make-object button% explosion-is panel-51-setting void)
  (make-object button% explosion-5-is panel-51-setting void)
  
  (send panel-6-setting set-alignment 'center 'center)
  (send panel-7-setting set-alignment 'center 'center)
  
  (make-object message% "" panel-dn-setting)
  (make-object button% "O&K" panel-dn-setting (lambda (bon ben)
                                                (vector-set! ships-vect 1 (add1 (send rbs1 get-selection)))
                                                (vector-set! ships-vect 2 (add1 (send rbs2 get-selection)))
                                                (vector-set! ships-vect 3 (add1 (send rbs3 get-selection)))
                                                (vector-set! ships-vect 4 (add1 (send rbs4 get-selection)))
                                                (vector-set! ships-vect 5 (add1 (send rbs5 get-selection)))
                                                (set! show? (zero? (send rbs51 get-selection)))
                                                (set! WIDTH (+ 5 (send rbs6 get-selection)))
                                                (set! HEIGHT WIDTH)
                                                (if (eq? game-type 1)
                                                (set! his-grid-vect 
                                                  (build-vector WIDTH (lambda(i) (make-vector HEIGHT 'not-set))))
                                                (set! his-grid-vect 
                                                  (build-vector WIDTH (lambda(i) (make-vector HEIGHT 'not-cheked)))))
                                                (set! my-grid-vect 
                                                  (build-vector WIDTH (lambda(i) (make-vector HEIGHT 'not-set))))
                                                (set! coulee 
                                                  (build-vector WIDTH (lambda(i) (make-vector HEIGHT 0))))
                                                (set! coulee1 
                                                  (build-vector WIDTH (lambda(i) (make-vector HEIGHT 0))))
                                                (set! nb-bombs (do ((i 1 (add1 i))
                                                                    (sigma 0 (+ sigma (* i (vector-ref ships-vect i)))))
                                                                 ((= i (vector-length ships-vect)) sigma)))
                                                (set! nb-ships (do ((i 1 (add1 i))
                                                                    (sigma 0 (+ sigma (vector-ref ships-vect i))))
                                                                 ((= i (vector-length ships-vect)) sigma)))
                                                (if (= game-type 1)
                                                    (set! level (add1 (send rbs7 get-selection)))
                                                    (set! host? (zero? (send rbs7 get-selection))))
                                                (if (< (* WIDTH HEIGHT) nb-bombs)
                                                      (begin
                                                        (set! frame-setting (make-object frame% "Game Settings"))
                                                        (setting-main 'bon 'ben))
                                                      (begin
                                                      (if (eq? game-type 1)
                                                      (begin
                                                        (insert-ships 'his)
                                                        (fill-rest his-grid-vect)))
                                                (send super-frame show #t)
                                                (send frame-setting show #f)
                                                (init his-pasteboard uncovered-is)
                                                (init my-pasteboard uncovered-is)))))
  (make-object button% "E&xit" panel-dn-setting (lambda (bon ben) 
                                                    (send frame-setting show #f)
                                                    (send super-frame show #f))))

(define (init-my-grid-1 bon ben)
  (define frame-init-1 (make-object frame% "ALERT"))
  (send frame-init-1 show #t)
  (make-object message% "" frame-init-1)
  (make-object message% "Please Choose the kind of the ship" frame-init-1)
  (make-object message% "Unless You change the settings You can have" frame-init-1)
  (make-object message% "8 ships : 1-1 2-2 2-3 2-4 and 1-5" frame-init-1)
  (make-object message% "" frame-init-1)
  (make-object button% "That's Ok" frame-init-1 init-my-grid-2)
  (make-object button% "Take Me To The Settings" frame-init-1 setting-main))

(define (init-my-grid-2 bon ben)
  (define frame-init-2 (make-object frame% "My Grid Init"))
  (define msg-init (make-object message% "Read The Instructions" frame-init-2))
        
  (send frame-init-2 show #t)
  
  (do ((i 1 (add1 i)))
    ((= i 6) (send message set-label "Init : OK !"))
    (do ((j 1 (add1 j)))
      ((> j (vector-ref ships-vect i)))
      (make-object message% (string-append "please pose the " (number->string i) "-cell-long ship") frame-init-2)))
  
  (make-object button% "All Done" frame-init-2 (lambda (bon ben) (send frame-init-2 show #f)(test)))
  (make-object button% "Cancel" frame-init-2 init-my-grid-1)

  )

(define (bidon mouse event) ())

(make-object button% "My Turn" hp-down-2 (lambda (bon ben) 
                                           (if (eq? game-type 1)
                                               void
                                               (send his-pasteboard my-turn))))
(make-object message% " " hp-down-2)
(make-object message% "Select to pose" hp-down-2)
(make-object message% " : " hp-down-2)
(make-object message% "TYPE-1" hp-down-2)
(make-object button% type-1-is hp-down-2 (lambda (bon ben) (set! nb-to-pose 1)))
(make-object message% "TYPE-2" hp-down-2)
(make-object button% type-2-is hp-down-2 (lambda (bon ben) (set! nb-to-pose 2)))
(make-object message% "TYPE-3" hp-down-2)
(make-object button% type-3-is hp-down-2 (lambda (bon ben) (set! nb-to-pose 3)))
(make-object message% "TYPE-4" hp-down-2)
(make-object button% type-4-is hp-down-2 (lambda (bon ben) (set! nb-to-pose 4)))
(make-object message% "TYPE-5" hp-down-2)
(make-object button% type-5-is hp-down-2 (lambda (bon ben) (set! nb-to-pose 5)))
(make-object message% "And In Case You Changed Your Mind : " hp-down-2)
(make-object button% "Reset" hp-down-2 (lambda (bon ben) 
                                         (if game-started? 
                                             (send message set-label "IMPOSSIBLE ! game already started!")
                                             (reset))))
(define my-menu (make-object menu-bar% super-frame))

(define file (make-object menu% "File" my-menu))
(make-object menu-item% "Exit" file (lambda (bon ben)
                                      (set! end-of-game? #t)
                                      (send super-frame show #f)))

(define setting (make-object menu% "Se&ttings" my-menu))
(make-object menu-item% "Nbr Of &Ships" setting can-set?)

(define help (make-object menu% "Help" my-menu))
(make-object menu-item% "Local Help" help bidon)
(make-object menu-item% "The Web Site" help bidon)
(make-object separator-menu-item% help)
(make-object menu-item% "Helpful Links" help bidon)

(define about (make-object menu% "About" my-menu))
(make-object menu-item% "Author" about bidon)
(make-object menu-item% "Version" about bidon)
(make-object separator-menu-item% about)
(make-object menu-item% "Contact" about bidon)

(setting-main 'bon 'ben)

(define redraw-canvas%
    (class canvas% (frame bitmap)
      (inherit get-dc)
      (override
        [on-paint (lambda () 
                    (send (get-dc) draw-bitmap bitmap 0 0)
                    (send init-window set-status-text " Loading ...")(sleep/yield 0.75)
                    (send init-window set-status-text " Loading definitions.scm ...")(sleep/yield 0.75)
                    (send init-window set-status-text " Loading functions.scm ...")(sleep/yield 0.75)
                    (send init-window set-status-text " Loading his-grid.scm ...")(sleep/yield 0.75)
                    (send init-window set-status-text " Loading my-grid.scm ...")(sleep/yield 0.75)
                    (send init-window set-status-text " Loading menu.scm ...")(sleep/yield 0.75)
                    (send init-window set-status-text " End Of Loading ...")(sleep/yield 0.75)
                    (send init-window set-status-text 
                          "                          ALLOUCH Bachir - UNSA - 2002 ")(sleep/yield 3.5))])
      (sequence (super-init frame))))

(define init-window (make-object frame% "Naval Combat : Loading ..." #f #f #f #f #f 
                      '(no-resize-border no-caption no-system-menu)))
(send init-window stretchable-height #f)
(send init-window stretchable-width #f)
(send init-window create-status-line)
(define bitmap (make-object bitmap% "o1.jpg" 'jpeg))
(define canvas (make-object redraw-canvas% init-window bitmap))
(send canvas min-client-width (send bitmap get-width))
(send canvas min-client-height (send bitmap get-height))
(send init-window center 'both)
(send init-window show #t)
(send init-window set-status-text "Loading ...")
(sleep/yield 2)
(send frame-setting show #t)
(send init-window show #f)

(set! nb-bombs
  (do ((i 1 (add1 i))(sigma 0 (+ sigma (* i (vector-ref ships-vect i)))))
    ((= i (vector-length ships-vect)) sigma)))
(set! nb-ships
  (do ((i 1 (add1 i))(sigma 0 (+ sigma (vector-ref ships-vect i))))
    ((= i (vector-length ships-vect)) sigma)))